option add *highlightThickness 0
wm title . {System Performance Monitor}
canvas .c -width 140 -height 27 -bd 2 -relief raised
set fg [option get . foreground Foreground]
if \"$fg\"=="" {set fg black}
pack .c
set font -adobe-helvetica-bold-r-normal-*-8-80-75-75-p-50-iso8859-1
.c create text 30 7 -text Core -anchor e -fill $fg -font $font
.c create text 30 15 -text Swap -anchor e -fill $fg -font $font
.c create text 30 23 -text CPU -anchor e -fill $fg -font $font
.c create line 35 7 60 7 -width 5 -fill red -tags coreUsed
.c create line 60 7 80 7 -width 5 -fill blue -tags coreBuffer
.c create line 80 7 135 7 -width 5 -fill green -tags coreFree
.c create line 35 15 70 15 -width 5 -fill red -tags swapUsed
.c create line 70 15 135 15 -width 5 -fill green -tags swapFree
.c create line 35 23 55 23 -width 5 -fill red -tags usr
.c create line 55 23 70 23 -width 5 -fill yellow -tags nice
.c create line 70 23 85 23 -width 5 -fill blue -tags sys
.c create line 85 23 135 23 -width 5 -fill green -tags idle
set CpuUpdateTime 100
set CpuAveragingWindow 400
set MemUpdateTime 500

bind .c <Double-Button-1> SetupDialog

proc SetupDialog {} {
  global CpuUpdateTime CpuAveragingWindow MemUpdateTime
  toplevel .d
  wm title .d {Performance Monitor Setup}
  frame .d.f
  scale .d.f.s1 -from 100 -to 2000 -length 300 -orient horizontal \
     -label {CPU statistics update interval (ms)} -bd 2 -relief sunken
  .d.f.s1 set $CpuUpdateTime
  pack .d.f.s1 -side top -pady 10 -padx 5
  scale .d.f.s2 -from 100 -to 5000 -length 300 -orient horizontal \
     -label {CPU statistics averaging interval (ms)} -bd 2 -relief sunken
  .d.f.s2 set $CpuAveragingWindow
  pack .d.f.s2 -side top -pady 10 -padx 5
  scale .d.f.s3 -from 250 -to 5000 -length 300 -orient horizontal \
     -label {Memory statistics update interval (ms)} -bd 2 -relief sunken
  .d.f.s3 set $MemUpdateTime
  pack .d.f.s3 -side top -pady 10 -padx 5
  pack .d.f -side top
  button .d.ok -text {OK} -command {
    set CpuUpdateTime [.d.f.s1 get]
    set CpuAveragingWindow [.d.f.s2 get]
    set MemUpdateTime [.d.f.s3 get]
    destroy .d
  }
  pack .d.ok -side right -padx 10 -pady 5
  button .d.cancel -text {Cancel} -command {
    destroy .d
  }
  pack .d.cancel -side right -padx 10 -pady 5
}
